package com.dummy.time;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public class SimpleTimeProvider implements TimeProvider {
  @Override
  public Date getTime() {
    return new Date();
  }

  @Override
  public Date getToday() {
    GregorianCalendar cal = new GregorianCalendar();
    cal.set(Calendar.HOUR_OF_DAY, 0);
    cal.set(Calendar.MINUTE, 0);
    cal.set(Calendar.SECOND, 0);
    cal.set(Calendar.MILLISECOND, 0);
    return cal.getTime();
  }

  @Override
  public int getThisYear() {
    Calendar cal = new GregorianCalendar();
    cal.setTime(getTime());
    return cal.get(Calendar.YEAR);
  }

  @Override
  public int getThisMonth()
  {
    Calendar cal = new GregorianCalendar();
    cal.setTime(getTime());
    return cal.get(Calendar.MONTH);
  }

  @Override
  public int getThisDay()
  {
    Calendar cal = new GregorianCalendar();
    cal.setTime(getTime());
    return cal.get(Calendar.DAY_OF_MONTH);
  }

}
