package com.dummy.web;

import java.io.Serializable;
import java.util.Date;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.enterprise.context.spi.CreationalContext;
import javax.enterprise.inject.spi.Bean;
import javax.enterprise.inject.spi.BeanManager;
import javax.inject.Inject;
import javax.inject.Named;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.dummy.core.LocalTimeProvider;


@Named
@SessionScoped
public class TestHandler implements Serializable {
  private static final long serialVersionUID = 1L;

  @Inject
  private LocalTimeProvider timeProvider1;
  
  private LocalTimeProvider timeProvider2;
  
  @EJB
  private LocalTimeProvider timeProvider3;

  private LocalTimeProvider timeProvider4;

  @Inject
  private BeanManager beanManager;
  
  
  @SuppressWarnings("unused")
  @PostConstruct
  private void postConstruct()
  {
    //Just for the fun, the same as @Inject
    @SuppressWarnings("unchecked")
    Bean<LocalTimeProvider> bean = (Bean<LocalTimeProvider>) beanManager.resolve(beanManager.getBeans(LocalTimeProvider.class));
    CreationalContext<LocalTimeProvider> ctx = beanManager.createCreationalContext(bean);
    timeProvider2 = (LocalTimeProvider) beanManager.getReference(bean, LocalTimeProvider.class, ctx);
    
    try {
      //Just for the fun, the same as with @EJB
      timeProvider4 = (LocalTimeProvider)new InitialContext().lookup("java:app/truc-core/TimeProvider");
    }
    catch (NamingException e) {
      throw new RuntimeException(e);
    }
  }


  public int getThisYear() {
    return timeProvider1.getThisYear();
  }


  public int getThisMonth() {
    return timeProvider2.getThisMonth();
  }


  public int getThisDay() {
    return timeProvider3.getThisDay();
  }

  public Date getTime() {
    return timeProvider4.getTime();
  }
}
